// 1.1 make a GUI
(
~xypoint = Buffer.alloc(s,2);
~entry = FluidDataSet(s);
~gestureXY = Buffer(s);
~count = 0;

SynthDef(\writer, {var trig = Impulse.kr(50); FluidDataSetWr.kr(~entry, buf: ~xypoint, idNumber: PulseCount.kr(trig),trig:trig)}).send;

FluidPlotter(bounds: Rect(top: Window.screenBounds.height-400, width: 400,height: 400), mouseMoveAction: {|...in|
	if (in[5].notNil, {
		//clear the ds
		~entry.clear;
		in[0].dict = Dictionary.newFrom(["cols",2,"data",Dictionary.newFrom([])]);
		//write the value to buf
		~xypoint.setn(0,in[[1,2]]);
		//start the writer function that has a constant frequency
		~timedWriter = Synth(\writer);
	}, {
		if (in[4].notNil, {
			//stop the writer function
			~timedWriter.free;
			//transfer to buf
			~entry.toBuffer(~gestureXY);
		}, {
			~xypoint.setn(0,in[[1,2]]);
			in[0].addPoint_(~count.asSymbol,in[1],in[2]);
			~count = ~count + 1;
		});
	});
})
)

// 1.2 in the Plotter, draw a gesture
// 1.3 look at the 2d buffer of the gesture in time (channel 0 is x, channel 1 is y)
~gestureXY.plot

// 1.4 input that buffer as a series in FluidDataSeries

~series = FluidDataSeries(s)
~series.addSeries(\firstGesture, ~gestureXY)

// 1.5 print it and/or dump it
~series.print

// 1.6 draw another gesture in the GUI
// 1.7 add it to the FluidDataSeries
~series.addSeries(\secondGesture, ~gestureXY)

// dump
~series.dump{|x|x["data"].keys.postln;}